#ifndef INC_GTDISPLAY_H
#define INC_GTDISPLAY_H

#include <X11/Xlib.h>
#include <X11/Xresource.h>

#include "gtbase.h"
#include "gtcblist.h"

/************************************************************************\
*
* GtDisplay class header.
*
* $Ident: This file is part of the 'Gt-library' 1.0.0 $
* $Copyright: (C) 1997 by Gran Gustafsson $
*
\************************************************************************/

class GtDisplay : public GtBase
{
public:
		/* Standard */
	GtDisplay(void);
	void Destroy(void);
	sbool Init(GtTag *tgs);
	sbool Set(GtTag *tgs);
	void Get(GtTag *tgs);
	char *GetClass(void) { return("GtDisplay"); }
	sbool IsSubClassOf(char *cn);
		/* Events */
	virtual void HandleEvent(XEvent *xe);
		/* Values */
	inline int GetFD(void) { return(fd); }
	inline Display *XDsp(void) { return(dsp); }
	inline sbool Pending(void)
		{ return(XEventsQueued(dsp,QueuedAlready) || XPending(dsp)); }
					
		/* X Defaults !! These methods return X-resources !! */
	inline ulong XBlackPixel(void)
		{ return(BlackPixel(dsp,scr)); }
	inline ulong XWhitePixel(void)
		{ return(WhitePixel(dsp,scr)); }
	inline Colormap XDefaultColormap(void)
		{ return(DefaultColormap(dsp,scr)); }
	inline ulong XDefaultDepth(void)
		{ return(DefaultDepth(dsp,scr)); }
	inline Window XDefaultRootWindow(void)
		{ return(DefaultRootWindow(dsp)); }
	inline int XDefaultScreen(void)
		{ return(DefaultScreen(dsp)); }
	inline Visual *XDefaultVisual(void)
		{ return(DefaultVisual(dsp,scr)); }
	inline int XDisplayCells(void)
		{ return(DisplayCells(dsp,scr)); }
	inline int XDisplayPlanes(void)
		{ return(DisplayPlanes(dsp,scr)); }
	inline int XDisplayWidth(void)
		{ return(DisplayWidth(dsp,scr)); }
	inline int XDisplayHeight(void)
		{ return(DisplayHeight(dsp,scr)); }
protected:
	Display *dsp;
	ulong scr;
	int fd;
	sbool nofreex;
};

extern GtDisplay *GtMkDisplay(GtTag *tgs);
extern GtDisplay *GtMkDisplay(ulong tag,...);

#endif /* INC_GTDISPLAY_H */
