#ifndef INC_GTFRAME_H
#define INC_GTFRAME_H

#include "gtbdrman.h"

/************************************************************************\
*
* GtFrame class header.
*
* $Ident: This file is part of the 'Gt-library' 1.0.0 $
* $Copyright: (C) 1997 by Gran Gustafsson $
*
\************************************************************************/


class GtFrame : public GtBdrMan
{
public:
		/* Standard */
	GtFrame(void);
	sbool Init(char *n,GtManager *p,GtTag *tgs);
	sbool Set(GtTag *tgs);
	void Get(GtTag *tgs);
	char *GetClass(void) { return("GtFrame"); }
	sbool IsSubClassOf(char *cn);
		/* Child management */
	sbool AddChild(GtWidget *obj,ulong pos);
	void RemChild(GtWidget *obj);
	sbool SetLInfo(GtWidget *o,GtTag *tgs);
		/* Layout */
	void Relayout(void);
		/* Values */
	void SetEMask(ulong em);
protected:
		/* Internal methods */
	void Layout(void);
	sbool Draw(XEvent *xe);
protected:
		/* Instance variables */
	GtWidget *title;
	word tx,ty,tw,th;
	ubyte ftype,talign,ibw,ibdrw,bdrw;
};

extern GtFrame *GtMkFrame(char *n,GtManager *p,GtTag *tgs);
extern GtFrame *GtMkFrame(char *n,GtManager *p,ulong tag,...);

#endif /* INC_GTFRAME_H */
